import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.math.*;

  
 public class ModuliSpace {

     /**Here are the vertices*/

     public static int[] list0() {
	 int[] a={4,4,4,4,4,4};
	 return(a);
     }


     public static int[] list1(int q) {
	 int[][] a={
	     {8,8,8,0,0,0},
	     {8,0,0,8,8,0}, 
             {0,8,0,8,0,8},
	     {0,0,8,0,8,8}};
         return(a[q]);}


     public static int[] list2(int q) {
	 int[][] a={   
             {0,6,6,6,6,0},
             {6,0,6,6,0,6},
	     {6,6,0,0,6,6}};
         return(a[q]);
     }


     public static int[] code(int a) {
	 int[][] c={{-1,0,1,2},{0,-1,2,1},{1,2,-1,0},{2,1,0,-1}};
	 return(c[a]);
     }

     public static int convert(int[] a) {
	 int[] c=code(a[0]);
	 int b=c[a[1]];
	 return(b);
     }


     public static int[] list2Name(int q) {
	 int[][] a={{0,1,2,3},{0,2,1,3},{0,3,1,2}};
	 return(a[q]);
     }



     public static double[] project(int[] a) {
	 double[] b=new double[5];
	 for(int i=0;i<5;++i) b[i]=a[i];
	 return(b);
     }

     /**here a=0,1,2*/
     public static int[][] simplex3(int a) {
	 int[][] m=new int[6][6];
	 for(int i=0;i<4;++i) m[i]=list1(i);
	 int count=4;

	 for(int i=0;i<3;++i) {
	     if(i!=a) {
		 m[count]=list2(i);
		 ++count;
	     }
	 }
	 return(m);
     }

     /**here a=0,1,2,3*/
     public static int[][] simplex4(int a) {
	 int[][] m=new int[6][6];
	 for(int i=0;i<3;++i) m[i]=list2(i);
	 int count=3;

	 for(int i=0;i<4;++i) {
	     if(i!=a) {
		 m[count]=list1(i);
		 ++count;
	     }
	 }
	 return(m);
     }

     /**here a=0,1,2,3 and b=0,1,2,3 and b!=a*/
     public static int[][] simplex12(int a,int b) {
	 int[] I0={a,b};
	 int I=convert(I0);
	 int[][] m=new int[6][6];
	 m[0]=list0();
	 m[1]=list1(b);

	 int count=2;
	 for(int i=0;i<4;++i) {
	     if((i!=a)&&(i!=b)) {
		 m[count]=list1(i);
		 ++count;
	     }
	 }
	 for(int i=0;i<3;++i) {
	     if(i!=I) {
		 m[count]=list2(i);
		 ++count;
	     }
	 }
	 return(m);
     }


     public static int[] average(int[] a,int[] b) {
	 int[] c=new int[6];
	 for(int i=0;i<6;++i) c[i]=(a[i]+b[i])/2;
	 return(c);
     }

     public static int[][] sub(int i,int j,int[][] a) {
	 int[][] b=new int[6][6];
	 b[0]=a[0];
	 b[1]=a[1];
	 b[2]=average(a[2],a[3]);
	 b[3]=average(a[4],a[5]);
	 b[4]=a[2+i];
	 b[5]=a[4+j];
	 return(b);
     }

     /**a=0,1,2,3, b=0,1,2,3, b!=a, i=0,1, j=0,1*/
     public static int[][] simplex48(int a,int b,int i,int j) {
	 int[][] A=simplex12(a,b);
	 A=sub(i,j,A);
	 return(A);
     }




     /**This lets us do big calculations without worrying about overflow*/

     public static BigInteger[] map(BigInteger[][] a,BigInteger[] u) {
	 BigInteger[] b=new BigInteger[6];
	 for(int i=0;i<6;++i) b[i]=new BigInteger("0");
	 for(int q=0;q<6;++q) {
	     for(int r=0;r<6;++r) {
		 b[r]=b[r].add(u[q].multiply(a[q][r]));
	     }
	 }
	 return(b);
     }

     public static BigInteger[][] big(int[][] a) {
	 BigInteger[][] b=new BigInteger[6][6];
	 for(int i=0;i<6;++i) {
	     for(int j=0;j<6;++j) {
		 b[i][j]=copy(a[i][j]);
	     }
	 }
	 return(b);
     }

    public static BigInteger copy(int a) {
	Integer A=new Integer(a);
	BigInteger AA=new BigInteger(A.toString());
	return(AA);
    }


}

